/** @file
@code
***************************************************************************
    begin                : 
    written by           : 
    CVS                  : $RCSfile: database.h,v $
                           $Revision: 1.1 $
***************************************************************************
@endcode*/
#ifndef DATABASE_H
#define DATABASE_H

#ifdef WIN32
//disable the (stupid) warning "identifier was truncated in debug information"
// which happens because of the use of a map with two strings from the STL, which generates an identifier of more than 255 characters
#pragma warning(disable:4786)
#endif

#include <map>
#include <fstream>
//#include "demo_header.h"

///Maximum length of a single line of the database file.
#define MAXLINESIZE 1000
/** When used as the first character on a line, the line is treated specially,
 * according to the second character. When the second character is unknown, the line is ignored.
 */
#define CONTROL_CHAR '@'
/// Used after the CONTROL_CHAR, indicates that this line contains a key.
#define KEY_CHAR '>'
/// Used after the CONTROL_CHAR to place a comment into the file; functionally ignored.
#define COMMENT_CHAR '#'

/// Map for loading the database into memory. Contains two strings: a key and its data.
typedef map<string, string> db_map_type ;
typedef map<string, string>::value_type db_record;
typedef map<string, string>::iterator db_iter;

/**
Simple text-file based database for use in the demo_db application
*/
class Database {
public:
	Database();

	~Database();
	void Load(string filename);
	string Find(string key);
	void Clear();
	void Insert(string key, string data);

protected:
	db_map_type DB_Map;
};

#endif
