/** @file
@code
***************************************************************************
    begin                : 
    written by           : 
    CVS                  : $RCSfile: demo_db.h,v $
                           $Revision: 1.1 $

***************************************************************************
@endcode*/
#ifndef DEMO_DB_H
#define DEMO_DB_H

#include "demo_header.h"
#include "socket.h"
#include "database.h"

/// structure containing all elements of a tag; the Name, the Options and the Data.
struct TagType {
	string Name;
	string Options;
	string Data;
};


/**
Simple text-file based database demo-application.
Demonstrates interfacing with the PC_ethernet_driver.
Also useful as test-database for the driver.
*/
class demo_db {
public:
	demo_db();

	~demo_db();
	bool Init(int argc, char* argv[]);
	void Execution();
	void OpenDatabase(string name="");
	void StartSocket();
	void OpenFormatFiles();

protected:
	string DBFilename;
	Database DB;
	int ServerPort;
	string ServerIP;
	Socket DBClientSocket;
	string InputBuffer;
	bool Exit;
	string PC2Format;
	string DS175Format;
	string command;
    bool prompt;
protected:
	struct TagType ExtractTag(string& input);
	string ProcessRequest(struct TagType data);
	string GetOption(string options, string item);
	string Database_Lookup(string key);
	string FormatDS175(string data);
	string FormatPC2(string data);
	bool CommandParser();
	bool ReadCommand();

};

#endif
