/** @file
@code
***************************************************************************
    CVS                  : $RCSfile: socket.cpp,v $
                           $Revision: 1.1 $
***************************************************************************
@endcode*/
#include "demo_db.h"


Socket::Socket() {}

Socket::~Socket() {}


void Socket::Connect(const string& ip, int port) {
	#ifdef WIN32
	struct WSAData WSA;
	#endif
	unsigned long _true=1;
	unsigned long _false=0;
	int result;

	//==== set address =======
	// clear Ser4vAddress structure
	bzero(&ServAddress, sizeof(ServAddress));
	// fill the ServAddress structure with IP...
	ServAddress.sin_addr.s_addr = inet_addr(ip.c_str());
	// ... port
	ServAddress.sin_port = htons(port);
	// ... and family
	ServAddress.sin_family = AF_INET;

	#ifdef WIN32
	WSAStartup(17, &WSA);
	#endif
	//==== create socket ======
	// create an internet-stream socket == TCP socket
	socket_fd = socket(AF_INET, SOCK_STREAM, 0);
	if (socket_fd < 0) {/*error*/
		throw "Socket::Connect - Socket creation failed (socket)";
	};

	//set non-blocking to false for connect
	result = ioctl(socket_fd, FIONBIO, &_false);
	if (result !=0){
		throw string("Socket::Connect - Setting blocking mode failed (ioctl)");
	};
	//==== connect socket =======
	result = connect(socket_fd, (SA*) &ServAddress, sizeof(ServAddress) );
	if (result < 0) {/*error*/
		throw string("Socket::Connect - Connection failed (connect)");
	};

	//set non-blocking true for normal operation
	result = ioctl(socket_fd, FIONBIO, &_true);
	if (result !=0){
		throw string("Socket::Connect - Setting non-blocking mode failed (ioctl)");
	};
}

string Socket::Read() {
	int count;
	char buf[READBUFSIZE];
	string S="";
	count = recv(socket_fd, buf, READBUFSIZE,0);
	if (count > 0) {
		S.assign(buf, count);
	};
	return S;
}

bool Socket::Write(string& data) {
	int count;
	while (data.size() >0) {
		count = send(socket_fd, data.c_str(), data.size(),0);
		if ((count > 0) && (count < data.size())) {
			data.erase(0, count);
		} else {
			data="";
		};
	};
	data="";
	return true;
}
