/** @file
@code
***************************************************************************
    begin                : 
    written by           : 
    CVS                  : $RCSfile: socket.h,v $
                           $Revision: 1.1 $
***************************************************************************
@endcode*/
#ifndef SOCKET_H
#define SOCKET_H

//#include "demo_header.h"

#ifdef WIN32
	#include <windows.h>
	#include <winsock.h>
	#include <io.h>
	///in Windows ioctlsocket is used instead of ioctl.
	#define ioctl ioctlsocket
#else
	#include <sys/socket.h>
	#include <arpa/inet.h>
#endif

#include <fcntl.h>


///simply a shortcut to improve readability
#define SA struct sockaddr

/**
Simple TCP client socket for use in the demo_db application.
*/
class Socket {
public:
	Socket();

	~Socket();
	void Connect(const string& ip, int port);
	string Read();
	bool Write(string& data);
protected:
	int socket_fd;
	struct sockaddr_in ServAddress;

};

#endif
